
// FOR THOSE OF YOU THAT IMPROVE UPON THIS HERE CODE I ASK YOU ONE THING
// PLEASE POST A COPY UP ON THE FOREX FORUMS FOR YOUR FELLOW TRADERS

#property indicator_chart_window
#property indicator_buffers 6

#define PI          3.14159265358979323846
#define MAXVALUE    1000000000
#define MINVALUE    0

#define PREFIX      "WAVE"
#define CYCLE       "CYCLE"
#define WAVE        "WAVE"


extern int    CalcBars = 1000;
extern int    SMAPeriod = 50;
extern int    SlopeBars = 3;
extern double SlopeDegree = 0.001;
extern int    StPeriodK = 5, StPeriodD = 3,  StSmooth = 2;
extern int    StMethod = MODE_EMA;
extern int    StPrice = 5;

extern double AreaHigh = 45, AreaLow = 55;

extern color  FallingColor    = Magenta;
extern int    FallingStyle    = STYLE_SOLID;
extern int    FallingWidth    = 5;
extern color  NeutralColor    = White;
extern int    NeutralStyle    = STYLE_SOLID;
extern int    NeutralWidth    = 5;
extern color  RisingColor     = Chartreuse;
extern int    RisingStyle     = STYLE_SOLID;
extern int    RisingWidth     = 5;
extern string FontName        = "Arial Bold";
extern int    FontSize        = 10;


double f[],n[],r[];
string letters = " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

static string License,encodeKey;

int init()
{
    SetIndexBuffer(0,f);
    SetIndexEmptyValue(0,EMPTY_VALUE);
    SetIndexStyle(0,DRAW_ARROW,FallingStyle,FallingWidth,FallingColor);
    SetIndexArrow(0, 159);
    SetIndexLabel(0, "Falling");

    SetIndexBuffer(1,n);
    SetIndexEmptyValue(1,EMPTY_VALUE);
    SetIndexStyle(1,DRAW_ARROW,NeutralStyle,NeutralWidth,NeutralColor);
    SetIndexArrow(1, 159);
    SetIndexLabel(1, "Neutral");

    SetIndexBuffer(2,r);
    SetIndexEmptyValue(2,EMPTY_VALUE);
    SetIndexStyle(2,DRAW_ARROW,RisingStyle,RisingWidth,RisingColor);
    SetIndexArrow(2, 159);
    SetIndexLabel(2, "Rising");
   
    return (0);
}

int deinit()
{
    DeleteObjects();
    
    return (0);
}

int start()
{

    int i,j,cb,trend,wave,letter,cyclebar,previouscyclebar,cyclecount,bar,wavebar,currenthighbar,currentlowbar,wavelowcycle,wavehighcycle;
    double sma,sma_prev,sma_slp,slope,st,st_prev,wavehigh,wavelow;
    bool startupcounting,startdowncounting,usingnumbers,highcycle,lowcycle;
    string wavetag;
    
    DeleteObjects();
    if (CalcBars > Bars)
        cb = Bars;
    else
        cb = CalcBars;
        
    trend = 2;
    startupcounting = false;
    startdowncounting = false;
    usingnumbers = false;
    letter = 0;
    wavehigh = 0;
    wavelow = 0;
    highcycle = false;
    lowcycle = false;
    cyclebar = 0;
    previouscyclebar = 0;
    cyclecount = 0;
    wavebar = 0;
    currenthighbar = 0;
    currentlowbar = 0;
    wavelowcycle = 0;
    wavehighcycle = 0;

   double llow[],hhigh[],cclose[],oopen[];
   ArrayResize(llow,Bars);
   ArrayCopy(llow,Low);
   ArrayResize(hhigh,Bars);
   ArrayCopy(hhigh,High);
   ArrayResize(cclose,Bars);
   ArrayCopy(cclose,Close);
   ArrayResize(oopen,Bars);
   ArrayCopy(oopen,Open);

    for (i=cb-1; i>=0; i--) 
    {
        sma = iMA(NULL,0,SMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
        sma_prev = iMA(NULL,0,SMAPeriod,0,MODE_EMA,PRICE_CLOSE,i+1);
        sma_slp = iMA(NULL,0,SMAPeriod,0,MODE_EMA,PRICE_CLOSE,i+SlopeBars);
        st = iStochastic(NULL,0,StPeriodK,StPeriodD,StSmooth,StMethod,StPrice,MODE_SIGNAL,i);
        st_prev = iStochastic(NULL,0,StPeriodK,StPeriodD,StSmooth,StMethod,StPrice,MODE_SIGNAL,i+1);

        slope = 180/PI*MathArctan((sma-sma_slp)/SlopeBars);


        if (slope > SlopeDegree) {
            f[i] = EMPTY_VALUE;
            n[i] = EMPTY_VALUE;
            r[i] = sma;
            r[i+1] = sma_prev;
            
            if (trend != 1) {
                trend = 1; 
   //             startupcounting = false; 
   //             startdowncounting = false; 
   //             usingnumbers = false;
   //             wave = 0; 
   //             letter = 0;
   //             wavehigh = MINVALUE;
   //             wavelow = MAXVALUE;
                cyclebar = i;
            }
        } else if (slope < -SlopeDegree) {
            f[i] = sma;
            f[i+1] = sma_prev;
            n[i] = EMPTY_VALUE;
            r[i] = EMPTY_VALUE;
            
            if (trend != -1) {
                trend = -1;
    //            startupcounting = false;
    //            startdowncounting = false;
    //            usingnumbers = false;
    //            wave = 0;
    //            letter = 0;
    //            wavehigh = MINVALUE;
    //            wavelow = MAXVALUE;
                cyclebar = i;
            }
        } else {
            f[i] = EMPTY_VALUE;
            n[i] = sma;
            n[i+1] = sma_prev;
            r[i] = EMPTY_VALUE;

            if (trend != 0) {
                trend = 0;
   //             startupcounting = false;
   //             startdowncounting = false;
   //             usingnumbers = false;
   //             wave = 0;
   //             letter = 0;
   //             wavehigh = MINVALUE;
   //             wavelow = MAXVALUE;
                cyclebar = i;
            }
        }
        
        if (!startupcounting && (trend == 1) && highcycle && (Close[i] > sma)) {
            startupcounting = true;
        }
        if (!startdowncounting && (trend == -1) && lowcycle && (Close[i] < sma)) {
            startdowncounting = true;
        }

        if (    ((st > AreaHigh) && (st_prev <= AreaHigh))                  ||
                (!highcycle && (st > AreaLow) && (st_prev <= AreaLow))      ) {
            highcycle = true;
            lowcycle = false;
            previouscyclebar = cyclebar;
            cyclebar = i;
            cyclecount++; 
            if (startupcounting || startdowncounting) 
                letter++;
            if ((trend == -1) && usingnumbers) 
                wave++;
        }

        if (    ((st < AreaLow) && (st_prev >= AreaLow))                    ||
                (!lowcycle && (st < AreaHigh) && (st_prev >= AreaHigh))     ){
            lowcycle = true;
            highcycle = false;
            previouscyclebar = cyclebar;
            cyclebar = i;
            cyclecount++;
            if (startupcounting || startdowncounting)
                letter++;
            if ((trend == 1) && usingnumbers)
                wave++;
        }

        if ( startupcounting ) {
            if ( lowcycle ) {
                if (wave > 1) {
                    wavebar = iLowest(NULL,0,MODE_LOW,cyclebar-i+1,i);
                    wavetag = StringSubstr(letters,letter,1);
                    DrawCycle(cyclecount, wavetag, wavebar, false, RisingColor);
                    
                    bar = iLowest(NULL,0,MODE_LOW,currenthighbar-i,i);
                    DrawWave(currenthighbar, wave, bar, false, RisingColor);
                }
            }
            if (highcycle) {
                if (currenthighbar <= cyclebar)
                    wavebar = iHighest(NULL,0,MODE_HIGH,currenthighbar-i+1,i);
                else
                    wavebar = iHighest(NULL,0,MODE_HIGH,cyclebar-i+1,i);
                for (j=i; j<=wavebar; j++) {
                    if ((Open[j] >= wavehigh) && (Close[j] > wavehigh)) {
                        wavebar = j;
                        break;
                    }
                }

                if (wavehighcycle == cyclecount) {
                    wavehigh = High[wavebar];
                    usingnumbers = true;
                    currenthighbar = wavebar;
                    letter = 0;
                    if (wave == 0)
                        wave++;
                } else
                    usingnumbers = false;
                if ((Open[wavebar] >= wavehigh) && (Close[wavebar] > wavehigh)) {
                    wavehigh = High[wavebar];
                    if (wavehighcycle != cyclecount)
                        wave++;
                    wavehighcycle = cyclecount; 
                    usingnumbers = true;                    
                    letter = 0;
                    currenthighbar = wavebar;
                }
                if ( usingnumbers )
                    wavetag = wave;
                else {
                    if (High[wavebar] > wavehigh) {
                        wavetag = "F"+(wave+1);
                        letter = 0;
                    } else
                        wavetag = StringSubstr(letters,letter,1);
                }
                DrawCycle(cyclecount, wavetag, wavebar, true, RisingColor);
            }
        }
        
        if( startdowncounting ) {
            if ( highcycle ) {
                if(wave > 1) {
                    wavebar = iHighest(NULL,0,MODE_HIGH,cyclebar-i+1,i);
                    wavetag = StringSubstr(letters,letter,1);
                    DrawCycle(cyclecount, wavetag, wavebar, true, FallingColor);

                    bar = iHighest(NULL,0,MODE_HIGH,currentlowbar-i,i);
                    DrawWave(currentlowbar, wave, bar, true, FallingColor);
                }
            }
            if ( lowcycle ) {
                if (currentlowbar <= cyclebar)
                    wavebar = iLowest(NULL,0,MODE_LOW,currentlowbar-i+1,i);
                else
                    wavebar = iLowest(NULL,0,MODE_LOW,cyclebar-i+1,i);
                for (j=i; j<=wavebar; j++) {
                    if ((Open[j] <= wavelow) && (Close[j] < wavelow)) {
                        wavebar = j;
                        break;
                    }
                }

                if (wavelowcycle == cyclecount) {
                    wavelow = Low[wavebar];
                    usingnumbers = true;
                    currentlowbar = wavebar;
                    letter = 0;
                    if (wave == 0)
                        wave++;
                } else
                    usingnumbers = false;
                if ((Open[wavebar] <= wavelow) && (Close[wavebar] < wavelow)) {
                    wavelow = Low[wavebar];
                    if(wavelowcycle != cyclecount)
                        wave++;
                    wavelowcycle = cyclecount;
                    usingnumbers = true;                    
                    letter = 0;
                    currentlowbar = wavebar;
                }
                if (usingnumbers)
                    wavetag = wave;
                else {
                    if(Low[wavebar] < wavelow) {
                        wavetag = "F"+(wave+1);
                        letter = 0;
                    } else
                        wavetag = StringSubstr(letters,letter,1);
                }
                DrawCycle(cyclecount, wavetag, wavebar, false, FallingColor);
            }
        }
    }

    return (0);
}

void DeleteObjects()
{
    int i;
    string name;

    i = 0;
    while (i < ObjectsTotal()) {
        name = ObjectName(i);
        if (StringFind(name, PREFIX + "_" + CYCLE + "_", 0) != -1) {
            ObjectDelete(name);
            i = 0;
        } else if (StringFind(name, PREFIX + "_" + WAVE + "_", 0) != -1) {
            ObjectDelete(name);
            i = 0;
        } else {
            i++;
        }
    }
}

void DrawCycle(int cycle, string text, int bar, bool above, color clr)
{
    string name;
    double price;

    name = PREFIX + "_" + CYCLE + "_" + cycle;
    ObjectDelete(name);

    if ( above )
        price = High[bar] + 0.5*iATR(NULL,0,10,bar);
    else
        price = Low[bar] - 0.5*iATR(NULL,0,10,bar);

 //   ObjectCreate(name, OBJ_TEXT, 0, Time[bar], price);
 //   ObjectSet(name,OBJPROP_COLOR,clr);
 //   ObjectSet(name,OBJPROP_BACK,true);
 //   ObjectSetText(name, text, FontSize, FontName, clr);
}

void DrawWave(int tag, string text, int bar, bool above, color clr)
{
    string name;
    double price;

    name = PREFIX + "_" + WAVE + "_" + tag;
    ObjectDelete(name);

    if ( above )
        price = High[bar] + iATR(NULL,0,10,bar);
    else
        price = Low[bar] - iATR(NULL,0,10,bar);

//    ObjectCreate(name, OBJ_TEXT, 0, Time[bar], price);
//    ObjectSet(name,OBJPROP_COLOR,clr);
//    ObjectSet(name,OBJPROP_BACK,true);
//    ObjectSetText(name, text, FontSize, FontName, clr);
}